dk.plugin "transport", ["server", "assets", "websockets"], ->
  transport = {}
  listeners = {}
  useWebsockets = false

  transport.config = (opts) ->
    if opts.websockets
      useWebsockets = true

  transport.run = ->
    dk.assets.package "/js/dk-transport.js",
                        "#{__dirname}/../public/js/dk-transport.coffee"
    dk.server.post "/dk/transport/:key", (req, res) ->
      key = req.param('key')
      if cb = listeners[key]
        console.log "DATA", req.body
        data = JSON.parse req.body.data
        cb data, (result) ->
          res.send result
      else
        res.send "Page not found", 404

    if useWebsockets
      dk.assets.package "/js/dk-transport-websockets.js",
                        "#{__dirname}/../public/js/dk-transport-websockets.coffee"
      console.log "Websockets", dk.websockets
      dk.websockets.on "message", (client, msg) ->
        {id, key, data} = msg
        if cb = listeners[key]
          cb data, (result) ->
            client.send id: id, data: result
        else
          client.send null

  transport.on = (msg, cb) ->
    listeners[msg] = cb

  return transport
